if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

// Takes care of the active document, detection, switching, etc.
com.wordstream.plugin.BrowserHandler =
{
    JOOMLA_CONTENT_IFRAME_ID: 'text_ifr',
    WORDPRESS_CONTENT_IFRAME_ID: 'content_ifr',
    WORDPRESS_MULTILANG_CONTENT_IFRAME_ID: 'qtrans_textarea_content_ifr',
    DRUPAL_CONTENT_AREA_ID: 'edit-body',
    BLOGGER_CONTENT_IFRAME_ID: 'postingComposeBox',
    TYPEPAD_CONTENT_IFRAME_ID: 'body_editor',
    EXPLORER_SERVER: "https://my.wordstream.com",
    activeHandler: null,
    wsWordSmith: null,
    ktWordSmith: null,
    mainWindow: window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow),
    session: Application.storage.get('com.wordstream.session', false),
    analyzeTimerId: null,
    ge: function(id) { return document.getElementById(id); },

    checkCurrentTab: function()
    {
        var currentDocument = this.mainWindow.gBrowser.selectedBrowser.contentDocument.wrappedJSObject;

        if (this.hasWordPress(currentDocument))
        {
            var contentIFrame = currentDocument.getElementById(this.WORDPRESS_CONTENT_IFRAME_ID);
            if (contentIFrame == null)
                contentIFrame = currentDocument.getElementById(this.WORDPRESS_MULTILANG_CONTENT_IFRAME_ID);

            this.activeHandler = new com.wordstream.plugin.IFrameHandler(contentIFrame);
        }
        else if (this.hasFCKEditor(currentDocument))
        {
            this.activeHandler = new com.wordstream.plugin.IFrameHandler(this.hasFCKEditor(currentDocument));
        }
        else if (this.hasDrupal(currentDocument))
        {
            var mainTextArea = currentDocument.getElementById(this.DRUPAL_CONTENT_AREA_ID);
            this.activeHandler = new com.wordstream.plugin.TextAreaHandler(mainTextArea);
        }
        else if (this.hasBlogger(currentDocument))
        {
            var contentIFrame = currentDocument.getElementById(this.BLOGGER_CONTENT_IFRAME_ID);
            this.activeHandler = new com.wordstream.plugin.IFrameHandler(contentIFrame);
        }
        else if (this.hasTypePad(currentDocument))
        {
            var contentIFrame = currentDocument.getElementById(this.TYPEPAD_CONTENT_IFRAME_ID);
            this.activeHandler = new com.wordstream.plugin.IFrameHandler(contentIFrame);
        }
        else if (this.hasJoomla(currentDocument))
        {
            var contentIFrame = currentDocument.getElementById(this.JOOMLA_CONTENT_IFRAME_ID);
            this.activeHandler = new com.wordstream.plugin.IFrameHandler(contentIFrame);
        }
        else if (this.hasGenericRichEditor(currentDocument))
        {
            this.activeHandler = new com.wordstream.plugin.IFrameHandler(this.hasGenericRichEditor(currentDocument));
        }
        else if (this.hasGenericTextEditor(currentDocument))
        {
            this.activeHandler = new com.wordstream.plugin.TextAreaHandler(this.hasGenericTextEditor(currentDocument));
        }
        else
        {
            this.activeHandler = null;
        }

        return this.activeHandler;
    },

    assessTab: function()
    {
        var mode = this.getHighlightMode();
        var handler = this.checkCurrentTab();

        if (handler != null)
        {
            var newText = handler.rescan();
            if (this.wsWordSmith != null)
            {
                var pb = null;
                if (handler instanceof com.wordstream.plugin.IFrameHandler)
                    pb = this.wsWordSmith._laxedPhraseSplitter;
                else
                    pb = this.wsWordSmith._phraseSplitter;
                this.wsWordSmith.analyzeDocument(newText, pb, mode, false);
                com.wordstream.plugin.sidebar.refreshProfileUI();
            }
            if (this.ktWordSmith != null)
            {
                var pb = null;
                if (handler instanceof com.wordstream.plugin.IFrameHandler)
                    pb = this.ktWordSmith._laxedPhraseSplitter;
                else
                    pb = this.ktWordSmith._phraseSplitter;
                this.ktWordSmith.analyzeDocument(newText, pb, mode, false);
                com.wordstream.plugin.sidebar.refreshKeywordToolUI();
            }
        }
        else
        {
            // Clear analysis when going to a blank tab, etc.
            if (this.wsWordSmith != null)
            {
                pb = this.wsWordSmith._phraseSplitter;
                this.wsWordSmith.analyzeDocument("", pb, 0, false);
                com.wordstream.plugin.sidebar.refreshProfileUI();
            }
            if (this.ktWordSmith != null)
            {
                pb = this.ktWordSmith._phraseSplitter;
                this.ktWordSmith.analyzeDocument("", pb, 0, false);
                com.wordstream.plugin.sidebar.refreshKeywordToolUI();
            }
        }
    },

    hasWordPress: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            if (iframeTags[i].hasOwnProperty('id'))
            {
                if (iframeTags[i].id == this.WORDPRESS_CONTENT_IFRAME_ID || iframeTags[i].id == this.WORDPRESS_MULTILANG_CONTENT_IFRAME_ID) return true;
            }
        }

        return false;
    },

    hasBlogger: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            if (iframeTags[i].hasOwnProperty('id'))
            {
                if (iframeTags[i].id == this.BLOGGER_CONTENT_IFRAME_ID)
                {
                    return true;
                }
            }
        }
        return false;
    },

    hasJoomla: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            if (iframeTags[i].hasOwnProperty('id'))
            {
                if (iframeTags[i].id == this.JOOMLA_CONTENT_IFRAME_ID)
                {
                    return true;
                }
            }
        }
        return false;
    },

    hasTypePad: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            if (iframeTags[i].hasOwnProperty('id'))
            {
                if (iframeTags[i].id == this.TYPEPAD_CONTENT_IFRAME_ID) return true;
            }
        }

        return false;
    },

    hasDrupal: function(currentDocument)
    {
        var textTags = currentDocument.getElementsByTagName('textarea');
        for (var i = 0; i < textTags.length; i++)
        {
            if (textTags[i].hasOwnProperty('id'))
            {
                if (textTags[i].id == this.DRUPAL_CONTENT_AREA_ID) return true;
            }
        }

        return false;
    },

    getHighlightMode: function()
    {
        var mode = 0;
        var selIndex = com.wordstream.plugin.sidebar.selectedStage;
        var selIndex2 = com.wordstream.plugin.sidebar.selectedLowerTab;
        if (selIndex2 == 0)
        {
            mode = 0
        }
        else if (selIndex2 == 1)
        {
            mode = 1;
        }
        else if (selIndex2 == 2)
        {
            mode = 2;
        }

        return mode;
    },

    hasGenericRichEditor: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            if (iframeTags[i].previousSibling instanceof HTMLTextAreaElement)
            {
                return iframeTags[i];
            }
        }

        return false;
    },

    hasFCKEditor: function(currentDocument)
    {
        var iframeTags = currentDocument.getElementsByTagName('iframe');
        for (var i = 0; i < iframeTags.length; i++)
        {
            var st_id = '' + iframeTags[i].getAttribute('id');
            if (st_id.indexOf('FCK') != -1)
            {
                var tags = iframeTags[i].contentWindow.document.getElementsByTagName('iframe');
                if (tags.length > 0) return tags[0];
            }
        }

        return false;
    },

    hasGenericTextEditor: function(currentDocument)
    {
        var textTags = currentDocument.getElementsByTagName('textarea');
        for (var i = 0; i < textTags.length; i++)
        {
            if (textTags[i].rows > 18)
                return textTags[i];
        }

        return false;
    },

    init: function()
    {
        this.mainWindow.gBrowser.tabContainer.addEventListener("TabSelect",
        function(e)
        {
            // On change tabs we call this...
            com.wordstream.plugin.BrowserHandler.assessTab();
        }, false);

        window.managerClass = this;
        window.addEventListener("load",
        function ()
        {
            com.wordstream.plugin.BrowserHandler.mainWindow.gBrowser.addEventListener("load",
            function(e)
            {
                if (e.originalTarget instanceof HTMLDocument)
                {
                    var win = e.originalTarget.defaultView;
                    if (win.frameElement)
                    {
                        win = win.top;
                    }
                    else
                    {
                        com.wordstream.plugin.BrowserHandler.assessTab();
                    }
                }
            }, true);

            com.wordstream.plugin.BrowserHandler.mainWindow.gBrowser.addEventListener("keydown",
                    function(e)
                    {
                        if (e.currentTarget.id == 'content')
                        {
                            com.wordstream.plugin.BrowserHandler.resetAnalyzeTimer();
                        }
                    }, true);

        }, false);
        return this;
    },

    setProfileWordSmith: function(ws)
    {
        var mode = this.getHighlightMode();
        this.wsWordSmith = ws;
        var handler = this.checkCurrentTab();

        if (handler != null)
        {
            var newText = handler.rescan();
            var pb = null;
            if (handler instanceof com.wordstream.plugin.IFrameHandler)
                pb = this.wsWordSmith._laxedPhraseSplitter;
            else
                pb = this.wsWordSmith._phraseSplitter;
            this.wsWordSmith.analyzeDocument(newText, pb, mode, false);
        }
    },

    setKeywordToolWordSmith: function(ws)
    {
        var mode = this.getHighlightMode();
        this.ktWordSmith = ws;

        var handler = this.checkCurrentTab();
        if (handler != null)
        {
            var newText = handler.rescan();
            var pb = null;
            if (handler instanceof com.wordstream.plugin.IFrameHandler)
                pb = this.ktWordSmith._laxedPhraseSplitter;
            else
                pb = this.ktWordSmith._phraseSplitter;
            var words = this.ktWordSmith.analyzeDocument(newText, pb, mode, false);
        }
    },

    launchExplorer: function()
    {
        var session = Application.storage.get('com.wordstream.session', false);
        if (!session.isActiveSession())
        {
            this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab(this.EXPLORER_SERVER + "/explorer");
        }
        else
        {
            this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab(this.EXPLORER_SERVER + '/explorer#skey=' + session.token + "&profile=" + escape(this.session.profile));
        }
    },

    launchUserGuide: function()
    {
        window.open ("http://www.wordstream.com/seo-tools-firefox-plugin");
    },

    launchVideo: function()
    {
        window.open ("http://www.wordstream.com/seo-tutorial");
    },

    tryWordStream: function()
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://www.wordstream.com/try");
    },

    tryWordStreamSEO: function()
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://www.wordstream.com/seo-free-trial");
    },

    forgotPassword: function()
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://www.wordstream.com/forgot-password");
    },

    googleSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://www.google.com/#q=" + escape(query));
    },

    googleBlogSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://blogsearch.google.com/blogsearch?q=" + escape(query));
    },

    twitterSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://twitter.com/#search?q=" + escape(query));
    },

    techSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://technorati.com/search?return=posts&authority=high&q=" + escape(query));
    },

    yahooSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://search.yahoo.com/search?p=" + escape(query));
    },

    bingSearch: function(query)
    {
        this.mainWindow.gBrowser.tabContainer.selectedItem = this.mainWindow.gBrowser.addTab("http://www.bing.com/search?q=" + escape(query));
    },

    resetAnalyzeTimer: function()
    {
        if (this.analyzeTimerId != null)
        {
            clearTimeout(this.analyzeTimerId);
        }

        this.analyzeTimerId = setTimeout(function()
                {
                    com.wordstream.plugin.BrowserHandler.doAnalyze(false);
                }, 1000);
    },

    doAnalyze: function(highlight)
    {
        var mode = this.getHighlightMode();
        var handler = this.checkCurrentTab();
        if (!handler) return;
        var words = [];
        var words1 = [];
        var words2 = [];

        if (this.wsWordSmith != null)
        {
            var newText = handler.rescan();
            var pb = null;
            if (handler instanceof com.wordstream.plugin.IFrameHandler)
                pb = this.wsWordSmith._laxedPhraseSplitter;
            else
                pb = this.wsWordSmith._phraseSplitter;
            words1 = this.wsWordSmith.analyzeDocument(newText, pb, mode, highlight);
            com.wordstream.plugin.sidebar.refreshProfileUI();
        }
        if (this.ktWordSmith != null)
        {
            var newText = handler.rescan();
            var pb = null;
            if (handler instanceof com.wordstream.plugin.IFrameHandler)
                pb = this.ktWordSmith._laxedPhraseSplitter;
            else
                pb = this.ktWordSmith._phraseSplitter;
            words2 = this.ktWordSmith.analyzeDocument(newText, pb, mode, highlight);
            com.wordstream.plugin.sidebar.refreshKeywordToolUI();
        }

        if (highlight)
        {
            var selIndex = com.wordstream.plugin.sidebar.selectedStage;
            if (selIndex == 0 && words2.length > 0)
            {
                handler.highlightUsedWords(words2);
            }
            if (selIndex == 1 && words1.length > 0)
            {
                handler.highlightUsedWords(words1);
            }
        }
    },

    deHighlight: function()
    {
        var handler = this.checkCurrentTab();
        if (!handler) return;

        handler.deHighlight();
    }
};


