if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};
if (!com.wordstream.plugin.RemoteCall) com.wordstream.plugin.RemoteCall = {};

com.wordstream.plugin.RemoteCall =
{
    parseOut: /^[^(]+\((.*)\)$/,
    getData: function(url, callback)
    {
        var req = new XMLHttpRequest();

        var respObj = function()
        {
            var resp = respObj.reqObj;
            if (resp.readyState == 4)
            {
                response = resp.responseText;
                var textObj = response.match(com.wordstream.plugin.RemoteCall.parseOut)[1];
                var jsonObj = JSON.parse(textObj);
                respObj.callback(jsonObj);
            }
        };
        respObj.callback = callback;
        respObj.reqObj = req;
        respObj.rc = this;

        req.open("GET", url, true);
        req.onreadystatechange = respObj;
        req.send(null);
    },

    getRawData: function(url, callback)
    {
        var req = new XMLHttpRequest();

        var respObj = function()
        {
            var resp = respObj.reqObj;
            if (resp.readyState == 4)
            {
                response = resp.responseText;
                respObj.callback(response);
            }
        };
        respObj.callback = callback;
        respObj.reqObj = req;
        respObj.rc = this;

        req.open("GET", url, true);
        req.onreadystatechange = respObj;
        req.send(null);
    }
};

com.wordstream.plugin.CallManager =
{
    mainWindow: window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow),
    GLOBAL_CALL_MAP: {},
    API_SERVER: 'https://api.wordstream.com',
    REMOTE_CALLS: {
                    'GET_GROUP_KEYWORDS': '/blogseo/get_group_keywords',
                    'GET_NICHES': '/blogseo/suggest_niches_from_keyword',
                    'AUTH_GET_PROFILES': '/authentication/get_profiles',
                    'AUTH_LOGIN': '/authentication/login',
                    'AUTH_LOGOUT': '/authentication/logout',
                    'RESP_CAPTCHA': '/authentication/captcha_response',
                    'GET_GROUP_HIERARCHY': '/blogseo/get_group_hierarchy',
                    'VALIDATE_SEO_INFO': '/blogseo/validate_seo_info',
                    'SIGNUP': '/blogseo/signup_seo',
                    'GET_CMS_INFO': '/blogseo/get_cms_info',
                    'GET_KEYWORDS': '/blogseo/get_keywords',
                    'GET_RELATED_TERMS': '/blogseo/get_related_terms',
                    'ASSOCIATE_CONTENT': '/blogseo/associate_content',
                    'GET_GROUP_PROPERTIES': '/blogseo/get_group_properties',
                    'SET_GROUP_PROPERTIES': '/blogseo/set_group_properties',
                    'SEARCH_ALL_KEYWORDS': '/blogseo/search_all_keywords',
                    'UPDATE_CMS_INFO': '/blogseo/update_cms_info',
                    'GET_EXPLORER_DOWNLOAD': '/blogseo/get_explorer_download',
                    'GET_TOP_TERMS': '/blogseo/get_top_terms'
                    },

    _getSerial: function()
    {
        while (1)
        {
            var v = parseInt(Math.random() * 50000)
            if (!(v in this.GLOBAL_CALL_MAP))
            {
                this.GLOBAL_CALL_MAP[v] = null;
                return v;
            }
        }
    },

    actionSerial: function(serial)
    {
        var resultHandler = this.GLOBAL_CALL_MAP[serial]['resultHandler'];
        var data = this.GLOBAL_CALL_MAP[serial]['data'];
        var remoteMethod = this.GLOBAL_CALL_MAP[serial]['remoteMethod'];
        delete this.GLOBAL_CALL_MAP[serial];
        this.remoteCall(remoteMethod, data, resultHandler);
    },

    remoteCall: function(remote_method, myData, resultHandler)
    {
        window.setCursor('wait');

        var new_anon_responder = function (r)
        {
            window.setCursor('auto');

            if (r['code'] == 'CAPTCHA')
            {
                var result = com.wordstream.plugin.CallManager.mainWindow.openDialog("chrome://blog_seo/content/captcha.xul", "chrome=yes, resizable=no, minimizable=no, modal, centerScreen", window, new_anon_responder.serial);
            }
            else if (r['code'] == 'INSUFFICIENT_CREDITS')
            {
                var result = com.wordstream.plugin.CallManager.mainWindow.openDialog("chrome://blog_seo/content/nomorecredits.xul", "Insufficient Credits", "", "chrome=yes, resizable=no, minimizable=no, modal, centerScreen", null);
            }
            else
            {
                var resultHandler =  com.wordstream.plugin.CallManager.GLOBAL_CALL_MAP[new_anon_responder.serial]['resultHandler'];
                delete com.wordstream.plugin.CallManager.GLOBAL_CALL_MAP[new_anon_responder.serial];
                resultHandler(r);
            }
        }
        new_anon_responder.serial = this._getSerial();

        this.GLOBAL_CALL_MAP[new_anon_responder.serial] = {'resultHandler': resultHandler, 'remoteMethod': remote_method, 'data': myData};

        var rc = com.wordstream.plugin.RemoteCall;

        dlist = [];
        for (key in myData)
        {
            var val = '' + myData[key];
            var st = key + '=' + escape(val);
            dlist.push(st);
        }
        dstr = dlist.join('&');
        if (dstr != "")
            dstr = '&' + dstr;
        rc.getData(this.API_SERVER + this.REMOTE_CALLS[remote_method] + '?callback=nullback' + dstr, new_anon_responder);
    }
}