if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

com.wordstream.plugin.CMSSpawner = function()
{
    this.session = null;
    this.CMSUserId = "";
    this.CMSPassword = "";
    this.CMSPlatform = "";
    this.CMSLoginURL = "";
    this.CMSContentURL = "";
    this.CMSSelfHosted = 0;
    this.CMSPlatforms = [];
    this.tab = false;

    this.spawnCMS = function(tab)
    {
        this.session = Application.storage.get('com.wordstream.session', false);
        this.mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow);
        this.tabContainer = this.mainWindow.gBrowser.tabContainer;
        this.tabContainer.managerClass = this;
        this.gBrowser = this.mainWindow.gBrowser;
        this.tab = tab;
        com.wordstream.plugin.CallManager.remoteCall('GET_CMS_INFO', {'session_id': this.session.SESSION_ID, 'profile': this.session.profile}, this.gotCMSInfo);
    };

    this.gotCMSInfo = function(r)
    {
        if (r['code'] == 'OK')
        {
            var cms = com.wordstream.plugin.CMSSpawner.getInstance();
            cms.CMSUserId = r['data']['cms_username'];
            cms.CMSPassword = r['data']['cms_password'];
            cms.CMSPlatform = r['data']['cms_platform'];
            cms.CMSLoginURL = r['data']['cms_login_url'];
            cms.CMSContentURL = r['data']['cms_content_url'];
            cms.CMSPlatforms = r['data']['cms_platforms'];

            if (r['data']['cms_self_hosted'] == true)
            {
                cms.CMSSelfHosted = 1;
            }
            else
            {
                cms.CMSSelfHosted = 0;
            }

            if (cms.CMSPlatform == 'wordpress')
            {
                cms.launchWordPress(cms.CMSUserId, cms.CMSPassword);
            }
            else if (cms.CMSPlatform == 'blogger')
            {
                cms.launchBlogger(cms.CMSUserId, cms.CMSPassword);
            }
            else if (cms.CMSPlatform == 'drupal')
            {
                cms.launchDrupal(cms.CMSUserId, cms.CMSPassword, cms.CMSLoginURL, cms.CMSContentURL);
            }
            else if (cms.CMSPlatform == 'typepad')
            {
                cms.launchTypePad(cms.CMSUserId, cms.CMSPassword, cms.CMSLoginURL, cms.CMSContentURL);
            }

            if (cms.CMSUserId == "" || cms.CMSPassword == "")
            {
                window.openDialog("chrome://blog_seo/content/cmsinfo.xul", "", "chrome=yes, resizable=no, minimizable=no, modal, centerScreen", cms);
                window.close();
            }
        }
        else
        {
        }
    }
    this.gotCMSInfo.__classInst = this;

    this.launchWordPress = function (username, password)
    {
        var req = new XMLHttpRequest();
        var params = "log=" + escape(username) + "&pwd=" + escape(password) + "&testcookie=1&redirect_to=http%3A%2F%2Fwordpress.com%2F&submit=&rememberme=forever";

        if (this.CMSSelfHosted == 1)
        {
            req.open("POST", this.CMSLoginURL, true);
        }
        else
        {
            req.open("POST", "https://en.wordpress.com/wp-login.php", true);
        }
        req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        req.setRequestHeader("Content-length", params.length);
        req.setRequestHeader("Connection", "close");
        req.onreadystatechange = function ()
        {
            if (req.readyState == 4)
            {
                var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                // This means we've just logged in, now to fire the new

                var url = '';
                if (cmsspw.CMSSelfHosted == 1)
                {
                    url = cmsspw.CMSContentURL;
                }
                else
                {
                    url = "http://" + cmsspw.CMSUserId + ".wordpress.com/wp-admin/post-new.php"
                }

                if (cmsspw.tab == false)
                    window.open(url);
                else
                    cmsspw.tabContainer.selectedItem = cmsspw.gBrowser.addTab(url);
            }
        };
        req.send(params);
    }

    this.launchBlogger = function (username, password)
    {
        // Blogger requires a few stages to get right
        var req = new XMLHttpRequest();
        req.open("GET", "http://blogger.com", true);
        req.onreadystatechange = function ()
        {
            if (req.readyState == 4)
            {
                // Presumably what we need is in this response
                var response = req.responseText;
                var securityCode = response.match(/name="security_token"[^>]*value="([^"]*)"/);
                if (securityCode == null)
                {
                    var response = req.responseText;
                    var bid = response.match(/\<a id="newPostButton".*href="([^"]*)"[^>]*\>/);
                    // This means we've just logged in, now to fire the new

                    var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                    if (cmsspw.tab == false)
                        window.open("http://www.blogger.com" + bid[1]);
                    else
                        cmsspw.tabContainer.selectedItem = cmsspw.gBrowser.addTab("http://www.blogger.com" + bid[1]);
                    return;
                }

                securityCode = securityCode[1];

                var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                var req2 = new XMLHttpRequest();
                var params = "security_token=" + escape(securityCode) + "&d=%2Fhome&Email=" + escape(cmsspw.CMSUserId) + "&Passwd=" + escape(cmsspw.CMSPassword) + "&ok=Sign+in";
                req2.open("POST", "https:/www.blogger.com/start", true);
                req2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                req2.setRequestHeader("Content-length", params.length);
                req2.setRequestHeader("Connection", "keep-alive");
                req2.onreadystatechange = function ()
                {
                    if (req2.readyState == 4)
                    {
                        var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                        var req3 = new XMLHttpRequest();
                        req3.open("GET", "http:/www.blogger.com", true);
                        req3.onreadystatechange = function ()
                        {
                            if (req3.readyState == 4)
                            {
                                var response = req3.responseText;
                                var bid = response.match(/\<a id="newPostButton".*href="([^"]*)"[^>]*\>/);
                                // This means we've just logged in, now to fire the new

                                var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                                if (cmsspw.tab == false)
                                    window.open("http://www.blogger.com" + bid[1]);
                                else
                                    cmsspw.tabContainer.selectedItem = cmsspw.gBrowser.addTab("http://www.blogger.com" + bid[1]);
                            }
                        }
                        req3.send(null);
                    }
                };
                req2.send(params);
            }
        };
        req.send(null);
    }

    this.launchDrupal = function (username, password, loginURL, contentURL)
    {
        // Drupal requires a few stages to get right
        var req = new XMLHttpRequest();
        req.open("GET", loginURL, true);
        req.onreadystatechange = function ()
        {
            if (req.readyState == 4)
            {
                var response = req.responseText;
                var form_build_id = response.match(/\<input.+name="form_build_id".*value="([^"]*)"[^>]*\>/)[1];
                var form_id = response.match(/\<input.+name="form_id".*value="([^"]*)"[^>]*\>/)[1];

                var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                var req2 = new XMLHttpRequest();
                var params = "name=" + escape(cmsspw.CMSUserId) + "&pass=" + escape(cmsspw.CMSPassword) + "&form_build_id=" + escape(form_build_id) + "&form_id=" + escape(form_id) + "&op=Log+in";
                req2.open("POST", cmsspw.CMSLoginURL, true);
                req2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                req2.setRequestHeader("Content-length", params.length);
                req2.setRequestHeader("Connection", "keep-alive");
                req2.onreadystatechange = function ()
                {
                    if (req2.readyState == 4)
                    {
                        var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                        if (cmsspw.tab == false)
                            window.open(cmsspw.CMSContentURL);
                        else
                            cmsspw.tabContainer.selectedItem = cmsspw.gBrowser.addTab(cmsspw.CMSContentURL);
                    }
                };
                req2.send(params);
            }
        };
        req.send(null);
    }

    this.launchTypePad = function (username, password, loginURL, contentURL)
    {
        // TypePad does some encryption of the password
        var req = new XMLHttpRequest();
        req.open("GET", loginURL, true);
        req.onreadystatechange = function ()
        {
            if (req.readyState == 4)
            {
                var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                var response = req.responseText;
                var hash_token = response.match(/\<input.+name="token".*value="([^"]*)"[^>]*\>/)[1];
                var resp_token = com.wordstream.plugin.SHA1(hash_token + com.wordstream.plugin.SHA1(cmsspw.CMSPassword));

                var req2 = new XMLHttpRequest();
                var params = "active_form=typepad&token=" + escape(hash_token) + "&resp=" + escape(resp_token) + "&portal=typepad&tos_locale=en_US&username=" + cmsspw.CMSUserId + "&password=";
                req2.open("POST", cmsspw.CMSLoginURL, true);
                req2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                req2.setRequestHeader("Content-length", params.length);
                req2.setRequestHeader("Connection", "Keep-Alive");
                req2.onreadystatechange = function ()
                {
                    if (req2.readyState == 4)
                    {
                        var cmsspw = com.wordstream.plugin.CMSSpawner.getInstance();
                        if (cmsspw.tab == false)
                            window.open(cmsspw.CMSContentURL);
                        else
                            cmsspw.tabContainer.selectedItem = cmsspw.gBrowser.addTab(cmsspw.CMSContentURL);
                    }
                };
                req2.send(params);
            }
        };
        req.send(null);
    }
}

com.wordstream.plugin.CMSSpawner.getInstance = function()
{
    if (com.wordstream.plugin.CMSSpawner.__instance == undefined)
    {
        com.wordstream.plugin.CMSSpawner.__instance = new com.wordstream.plugin.CMSSpawner();
    }
    return com.wordstream.plugin.CMSSpawner.__instance;
}