if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

// Takes care of the active document, detection, switching, etc.
com.wordstream.plugin.ExplorerHandler =
{
    wsWordSmith: null,
    ktWordSmith: null,
    mainWindow: window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow),
    activeHandler: null,
    documentUID: 123,
    analyzeTimerId: null,

    checkCurrentTab: function()
    {
        var currentDocument = this.mainWindow.gBrowser.selectedBrowser.contentDocument.wrappedJSObject;

        // Are we on the WordStream explorer server?
        if (currentDocument.getElementById('Explorer') != null)
        {
            this.activeHandler = new com.wordstream.plugin.ExplorerPoller(currentDocument);
        }
        else
        {
            this.activeHandler = null;
        }
    },

    assessTab: function()
    {
        this.checkCurrentTab();
    },

    init: function()
    {
        this.mainWindow.gBrowser.tabContainer.addEventListener("TabSelect",
        function(e)
        {
            com.wordstream.plugin.ExplorerHandler.assessTab();
        }, false);

        window.managerClass = this;
        window.addEventListener("load",
        function ()
        {
            com.wordstream.plugin.ExplorerHandler.mainWindow.gBrowser.addEventListener("load",
            function(e)
            {
                if (e.originalTarget instanceof HTMLDocument)
                {
                    var win = e.originalTarget.defaultView;
                    if (win.frameElement)
                    {
                        win = win.top;
                    }
                    else
                    {
                        com.wordstream.plugin.ExplorerHandler.assessTab();
                    }
                }
            }, true);

        }, false);

        return com.wordstream.plugin.ExplorerHandler;
    },

    setOpenCloseStatus: function (status)
    {
        if (this.activeHandler != null)
        {
            this.activeHandler.openLauncher.launch = status;
        }
    }
}

com.wordstream.plugin.ExplorerPoller = function(dom)
{
    // First thing, inject our script into the head of the DOM
    var docHead = dom.getElementsByTagName('head')[0];
    var docBody = dom.getElementsByTagName('body')[0];

    var cArea = dom.getElementById('__control_area');
    if (cArea == null)
    {
        // Adding control area
        this.controlElement = dom.createElement('div');
        this.controlElement.id = '__control_area';
        this.controlElement.style.display = 'none';
        this.controlElement.setAttribute('launchPlugin', 'false');
        this.controlElement.setAttribute('launchCMS', 'false');
        this.controlElement.setAttribute('username', '');
        this.controlElement.setAttribute('password', '');

        docBody.appendChild(this.controlElement);

        var hookScript = dom.createElement('script');
        hookScript.type = 'text/javascript';
        hookScript.innerHTML = 'function sendControlMessage(propName, value) { document.getElementById("__control_area").setAttribute(propName, value); return true; };';
        docHead.appendChild(hookScript);
    }

    var checkShouldOpen = function()
    {
        var poller = checkShouldOpen.__poller;

        if (poller.controlElement.getAttribute('launchPlugin') == 'true')
        {
            poller.controlElement.setAttribute('launchPlugin', 'false');
            com.wordstream.plugin.global.enableBlogSEO();
        }

        if (poller.controlElement.getAttribute('launchCMS') == 'true')
        {
            poller.controlElement.setAttribute('launchCMS', 'false');
            com.wordstream.plugin.CMSSpawner.getInstance().spawnCMS(false);
        }
    };
    checkShouldOpen.__poller = this;

    this.pollTimer = setInterval(checkShouldOpen, 1000);
}
