if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

com.wordstream.plugin.WordStreamSEO = function()
{
    this.mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow);

    this.session = Application.storage.get('com.wordstream.session', false);
    this.ktWordSmith = null;
    this.wsWordSmith = null;
    this.keywords = [];
    this.groupings = [];
    this.numGroups = 0;
    this.groupHierarchy = {};
    this.queryTerms = {};
    this.selectedGroupId = 0;

    this.ghCallback = null;
    this.ghError = null;
    this.doAuthCallback = null;
    this.doAuthError = null;
    this.fnCallback = null;
    this.fnError = null;
    this.sgCallback = null;
    this.sgError = null;

    this.getGroupHierarchy = function(callback, error)
    {
        var session = Application.storage.get('com.wordstream.session', false);
        this.ghCallback = callback;
        this.ghError = error;
        com.wordstream.plugin.CallManager.remoteCall ('GET_GROUP_HIERARCHY', {'profile': session.profile, 'session_id': session.SESSION_ID}, function(r){ com.wordstream.plugin.WordStreamSEO.getInstance().gotGroupHierarchy(r); });
    }

    this.gotGroupHierarchy = function(r)
    {
        if (r['code'] == 'OK')
        {
            var data = r['data'];
            this.groupHierarchy = data['groups'][0];
            var num_groups = data['num_groups'];
            this.numGroups = num_groups;
            this.ghCallback(this.groupHierarchy, num_groups);
        }
        else
        {
            var error_detail = 'An unknown error has occurred';
            if ('detail' in r)
                error_detail = r['detail'];
            this.ghError(error_detail);
        }
    }

    // Authenticate with the server based on what the user typed
    this.doAuthenticate = function(email, password, callback, error)
    {
        this.doAuthCallback = callback;
        this.doAuthError = error;
        if (email.length == 0 || password.length == 0) return;

        com.wordstream.plugin.CallManager.remoteCall ('AUTH_LOGIN', {
                                   'username': email,
                                   'password': password,
                                   'list_profiles': 'true'
                                   },
            function(r)
            {
                var session = Application.storage.get('com.wordstream.session', false);
                var inst = com.wordstream.plugin.WordStreamSEO.getInstance();
                if (r['code'] == 'OK')
                {
                    session.SESSION_ID = r['data']['session_id'];
                    session.username = session.SESSION_ID.split(':')[0];
                    session.token = session.SESSION_ID.split(':')[1];
                    session.saveSessionData();
                    inst.getProfiles();
                }
                else
                {
                    session.clear();
                    var error_detail = 'An unknown error has occurred';
                    if ('detail' in r)
                        error_detail = r['detail'];
                    this.doAuthError(error_detail);
                }
            }
        );
    }

    this.getProfiles = function()
    {
        var session = Application.storage.get('com.wordstream.session', false)
        com.wordstream.plugin.CallManager.remoteCall('AUTH_GET_PROFILES', {'session_id': session.SESSION_ID},
            function(r)
            {
                var sess = Application.storage.get('com.wordstream.session', false);
                var inst = com.wordstream.plugin.WordStreamSEO.getInstance();
                if (r['code'] == 'OK')
                {
                    var profiles = r['data']['profiles'];
                    inst.doAuthCallback(profiles);
                }
                else
                {
                    session.clear();
                    inst.doAuthError();
                }
            }
        );
    }

    this.doLogout = function()
    {
        var session = Application.storage.get('com.wordstream.session', false);
        com.wordstream.plugin.CallManager.remoteCall ('AUTH_LOGOUT', {'session_id': session.SESSION_ID},
            function(r)
            {
                if (r['code'] == 'OK')
                {
                    com.wordstream.plugin.sidebar.doneLogout();
                }
                else
                {
                    var error_detail = 'An unknown error has occurred';
                    if ('detail' in r)
                        error_detail = r['detail'];
                    com.wordstream.plugin.sidebar.genericErrorHandler(error_detail);
                }
            }
        );
    }

    this.findNiches = function(keywords, callback, error)
    {
        var session = Application.storage.get('com.wordstream.session', false);
        this.fnCallback = callback;
        this.fnError = error;
        com.wordstream.plugin.CallManager.remoteCall ('GET_NICHES', {'keywords': keywords, 'session_id': session.SESSION_ID},
            function(r)
            {
                var inst = com.wordstream.plugin.WordStreamSEO.getInstance();
                if (r['code'] == 'OK')
                {
                    var data = r['data'];
                    inst.keywords = data['keywords'];
                    inst.groupings = data['groupings']
                    inst.fnCallback(inst.groupings);
                }
                else
                {
                    var error_detail = 'An unknown error has occurred';
                    if ('detail' in r)
                        error_detail = r['detail'];
                    inst.fnError(error_detail);
                }
            }
        );
    }

    this.ktWordSmithLoad = function(indCont)
    {
        var indices = [];
        var ktQueryTerms = {};
        for (var i = 0; i < indCont.length; i++)
        {
            indices.push(indCont[i][0]);
            for (var j = 0; j < indCont[i][1].length; j++)
            {
                ktQueryTerms[indCont[i][1][j]] = true;
            }
        }
        this.ktWordSmith = new com.wordstream.plugin.WordSmith(ktQueryTerms);
        this.ktWordSmith.setUpperLimit(100);

        for each (selectedIndex in indices)
        {
            var chosenGroup = this.groupings[selectedIndex];
            for each (matchIndex in chosenGroup['matches'])
            {
                this.ktWordSmith.add(this.keywords[matchIndex][0], this.keywords[matchIndex][1]);
            }
        }
    }

    this.selectGroups = function(groups, callback, error)
    {
        var session = Application.storage.get('com.wordstream.session', false);
        this.sgCallback = callback;
        this.sgError = error;
        this.queryTerms = {};
        var groupIds = [];

        for (var i = 0; i < groups.length; i++)
        {
            groupIds.push(groups[i][0]);
            for (var j = 0; j < groups[i][1].length; j++)
            {
                this.queryTerms[groups[i][1][j]] = true;
            }

        }

        if (groupIds.length == 0) return;
        this.selectedGroupId = groupIds[0];
        var gids = groupIds.join(',');

        com.wordstream.plugin.CallManager.remoteCall ('GET_GROUP_KEYWORDS', {'groups': gids, 'profile': session.profile, 'session_id': session.SESSION_ID}, function(r) { com.wordstream.plugin.WordStreamSEO.getInstance().gotGroupKeywords(r); });
    }

    this.gotGroupKeywords = function(r)
    {
        if (r['code'] == 'OK')
        {
            this.wsWordSmith = new com.wordstream.plugin.WordSmith(this.queryTerms);

            var data = r['data'];
            var count = data['keywords'].length;

            for each (keyword in data['keywords'])
            {
                this.wsWordSmith.add(keyword['k'], keyword['v']);
            }

            this.sgCallback();
        }
        else
        {
            var error_detail = 'An unknown error has occurred';
            if ('detail' in r)
                error_detail = r['detail'];
            this.sgError(error_detail);
        }
    }
}

// Return an instance of the sidebar object
com.wordstream.plugin.WordStreamSEO.getInstance = function()
{
    if (com.wordstream.plugin.WordStreamSEO.__instance == undefined)
    {
        com.wordstream.plugin.WordStreamSEO.__instance = new com.wordstream.plugin.WordStreamSEO();
    }

    return com.wordstream.plugin.WordStreamSEO.__instance;
}

