if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

com.wordstream.plugin.Session = function()
{
    this.SESSION_ID = "";
    this.username = "";
    this.token = "";
    this.profile = "";

    this.isRegisteredUser = function()
    {
        if (this.username != "")
        {
            return true;
        }

        return false;
    }

    this.isActiveSession = function()
    {
        if (this.token != "" && this.profile != "")
        {
            return true;
        }

        return false;
    }

    this.saveSessionData = function()
    {
        var sessionFile = this.__getHomePath() + "__ngblogseo.ini";

        try
        {
            netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        } catch (e)
        {
            alert("Unable to write session data, permission denied!");
        }
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(sessionFile);
        if (file.exists() == false)
        {
            file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
        }
        var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );
        /* Open flags
        #define PR_RDONLY       0x01
        #define PR_WRONLY       0x02
        #define PR_RDWR         0x04
        #define PR_CREATE_FILE  0x08
        #define PR_APPEND      0x10
        #define PR_TRUNCATE     0x20
        #define PR_SYNC         0x40
        #define PR_EXCL         0x80
        */
        /*
        ** File modes ....
        **
        ** CAVEAT: 'mode' is currently only applicable on UNIX platforms.
        ** The 'mode' argument may be ignored by PR_Open on other platforms.
        **
        **   00400   Read by owner.
        **   00200   Write by owner.
        **   00100   Execute (search if a directory) by owner.
        **   00040   Read by group.
        **   00020   Write by group.
        **   00010   Execute by group.
        **   00004   Read by others.
        **   00002   Write by others
        **   00001   Execute by others.
        **
        */
        outputStream.init(file, 0x04 | 0x08 | 0x20, 420, 0);
        var outStr = "username=" + escape(this.username) + "&token=" + escape(this.token) + "&profile=" + escape(this.profile);
        var result = outputStream.write(outStr, outStr.length);
        outputStream.close();
        Application.storage.set('com.wordstream.session', this);
    }

    this.loadSessionData = function()
    {
        var settingsFile = this.__getHomePath() + "__ngblogseo.ini";

        try {
            netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        } catch (e)
        {
            alert("Unable to read settings file, permission denied");
        }
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(settingsFile);
        if (file.exists() == false)
        {
            // No data in this file, no problem, they just need to log in
            this.clear();
            return;
        }
        var inStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance( Components.interfaces.nsIFileInputStream );
        inStream.init(file, 0x01, 00004, null);
        var scriptableInStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance( Components.interfaces.nsIScriptableInputStream );
        scriptableInStream.init(inStream);
        var data = scriptableInStream.read(scriptableInStream.available());
        tokens = data.split('&');
        for (var i = 0; i < tokens.length; i++)
        {
            var sub = tokens[i].split('=');
            if (sub.length > 1)
            {
                if (sub[0] == 'username')
                    this.username = unescape(sub[1]);
                else if (sub[0] == 'token')
                    this.token = unescape(sub[1]);
                else if (sub[0] == 'profile')
                    this.profile = unescape(sub[1]);
            }

        }

        if (this.token != "")
            this.SESSION_ID = this.username + ":" + this.token;
    }

    this.__getHomePath = function()
    {
        var dirService = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
        try
        {
            var path = (new dirService()).get("ProfD", Components.interfaces.nsIFile).path;
        }
        catch(e)
        {
            alert("Unable to query directory service");
        }

        if (path.search(/\\/) != -1)
        {
            path = path + "\\";
        }
        else
        {
            path = path + "/";
        }

        return path;
    }

    this.clear = function()
    {
        this.SESSION_ID = "";
        this.username = "";
        this.token = "";
        this.profile = "";
    }

    this.loadSessionData();
}

com.wordstream.plugin.Session.getInstance = function()
{
    if (com.wordstream.plugin.Session.__instance == undefined)
    {
        com.wordstream.plugin.Session.__instance = new com.wordstream.plugin.Session();
    }

    return com.wordstream.plugin.Session.__instance;
}
