if (!com) var com = {};
if (!com.wordstream) com.wordstream = {};
if (!com.wordstream.plugin) com.wordstream.plugin = {};

// Takes care of the active document, detection, switching, etc.
com.wordstream.plugin.VersionTracker =
{
    mainWindow: window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow),
    versionPollTimerId: null,
    versionMatcher: /version>(([0-9]+)\.([0-9]+)\.([0-9]+))/,
    thisVersion: [2, 1, 13],

    init: function()
    {
        // Update every 15 minutes
        this.pollTimer = setInterval(com.wordstream.plugin.VersionTracker.checkNewVersion, 15*1000*60);
    },

    checkNewVersion: function()
    {
        com.wordstream.plugin.RemoteCall.getRawData('https://www.wordstream.com/download/plug-ins/update.rdf', function (r) { com.wordstream.plugin.VersionTracker.gotVersionNumber(r); });
    },

    gotVersionNumber: function(data)
    {
        var groups = data.match(this.versionMatcher);
        var major = parseInt(groups[2]);
        var minor = parseInt(groups[3]);
        var fix = parseInt(groups[4]);

        var webVer = (major * 10000) + (minor * 100) + fix;
        var curVer = (this.thisVersion[0] * 10000) + (this.thisVersion[1] * 100) + this.thisVersion[2];


        if (webVer > curVer)
        {
            document.getElementById('updateAvailable').hidden = false;
            document.getElementById('updateAvailable').maxHeight = 30;
        }
    }
}